searchNodes=[{"doc":"The ExAliyunOts module provides a tablestore-based API as a client for working with Alibaba TableStore product servers. Here are links to official documents in Chinese | English Configuration config :ex_aliyun_ots , :my_instance name : &quot;MyInstanceName&quot; , endpoint : &quot;MyInstanceEndpoint&quot; , access_key_id : &quot;MyAliyunRAMKeyID&quot; , access_key_secret : &quot;MyAliyunRAMKeySecret&quot; config :ex_aliyun_ots , instances : [ :my_instance ] , debug : false , enable_tunnel : false debug , optional, specifies whether to enable debug logger, by default it's false, and please DO NOT use debug mode in production. enable_tunnel , optional, specifies whether to enable tunnel functions, there will startup tunnel related Supervisor and Registry when enable it, by default it's false. Using ExAliyunOts To use ExAliyunOts , a module that calls use ExAliyunOts has to be defined: defmodule MyApp.TableStore do use ExAliyunOts , instance : :my_instance end This automatically defines some macros and functions in the MyApp.TableStore module, here are some examples: import MyApp.TableStore # Create table create_table &quot;table&quot; , [ { &quot;pk1&quot; , :integer } , { &quot;pk2&quot; , :string } ] # Put row put_row &quot;table&quot; , [ { &quot;pk1&quot; , &quot;id1&quot; } ] , [ { &quot;attr1&quot; , 10 } , { &quot;attr2&quot; , &quot;attr2_value&quot; } ] , condition : condition ( :expect_not_exist ) , return_type : :pk # Search index search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : match_query ( &quot;age&quot; , 28 ) , sort : [ field_sort ( &quot;age&quot; , order : :desc ) ] ] # Local transaction start_local_transaction &quot;table&quot; , { &quot;partition_key&quot; , &quot;partition_value&quot; } ExAliyunOts API There are two ways to use ExAliyunOts: using macros and functions from your own ExAliyunOts module, like MyApp.TableStore . using macros and functions from the ExAliyunOts module. All defined functions and macros in ExAliyunOts are available and referable for your own ExAliyunOts module as well, except that the given arity of functions may different, because the instance parameter of each invoke request is NOT needed from your own ExAliyunOts module although the ExAliyunOts module defines it.","ref":"ExAliyunOts.html","title":"ExAliyunOts","type":"module"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore abort_transaction ( &quot;transaction_id&quot; )","ref":"ExAliyunOts.html#abort_transaction/2","title":"ExAliyunOts.abort_transaction/2","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore batch_get [ get ( table_name1 , [ [ { &quot;key1&quot; , 1 } , { &quot;key2&quot; , &quot;1&quot; } ] ] ) , get ( table_name2 , [ { &quot;key1&quot; , &quot;key1&quot; } ] , columns_to_get : [ &quot;name&quot; , &quot;age&quot; ] , filter : filter &quot;age&quot; &gt;= 10 ) ] The batch get operation can be considered as a collection of mulitple get/3 operations.","ref":"ExAliyunOts.html#batch_get/2","title":"ExAliyunOts.batch_get/2","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore batch_write [ { &quot;table1&quot; , [ write_delete ( [ { &quot;key1&quot; , 5 } , { &quot;key2&quot; , &quot;5&quot; } ] , return_type : :pk , condition : condition ( :expect_exist , &quot;attr1&quot; == 5 ) ) , write_put ( [ { &quot;key1&quot; , 6 } , { &quot;key2&quot; , &quot;6&quot; } ] , [ { &quot;new_put_val1&quot; , &quot;val1&quot; } , { &quot;new_put_val2&quot; , &quot;val2&quot; } ] , condition : condition ( :expect_not_exist ) , return_type : :pk ) ] } , { &quot;table2&quot; , [ write_update ( [ { &quot;key1&quot; , &quot;new_tab3_id2&quot; } ] , put : [ { &quot;new_put1&quot; , &quot;u1&quot; } , { &quot;new_put2&quot; , 2.5 } ] , condition : condition ( :expect_not_exist ) ) , write_put ( [ { &quot;key1&quot; , &quot;new_tab3_id3&quot; } ] , [ { &quot;new_put1&quot; , &quot;put1&quot; } , { &quot;new_put2&quot; , 10 } ] , condition : condition ( :expect_not_exist ) ) ] } ] The batch write operation can be considered as a collection of multiple write_put/3 , write_update/2 and write_delete/2 operations. Options :transaction_id , optional, batch write operation within local transaction. :is_atomic , optional, defaults to false, whether set this batch write request be with an atomic operation, if this option is true , keep the partition key of each table in the batch write operation is unique, or the corresponding write operation of the table will fail.","ref":"ExAliyunOts.html#batch_write/3","title":"ExAliyunOts.batch_write/3","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore commit_transaction ( &quot;transaction_id&quot; )","ref":"ExAliyunOts.html#commit_transaction/2","title":"ExAliyunOts.commit_transaction/2","type":"function"},{"doc":"Official document in Chinese | English","ref":"ExAliyunOts.html#compute_split_points_by_size/3","title":"ExAliyunOts.compute_split_points_by_size/3","type":"function"},{"doc":"Query current supported maximum number of concurrent tasks to parallel_scan/4 request. Official document in Chinese | English","ref":"ExAliyunOts.html#compute_splits/3","title":"ExAliyunOts.compute_splits/3","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore update_row &quot;table&quot; , [ { &quot;pk&quot; , &quot;pk1&quot; } ] , delete_all : [ &quot;attr1&quot; , &quot;attr2&quot; ] , return_type : :pk , condition : condition ( :expect_exist ) The available existence options: :expect_exist | :expect_not_exist | :ignore , here are some use cases for your reference: Use condition(:expect_exist) , expect the primary keys to row is existed. for put_row/5 , if the primary keys have auto increment column type, meanwhile the target primary keys row is existed, only use condition(:expect_exist) can successfully overwrite the row. for update_row/4 , if the primary keys have auto increment column type, meanwhile the target primary keys row is existed, only use condition(:expect_exist) can successfully update the row. for delete_row/4 , no matter what primary keys type are, use condition(:expect_exist) can successfully delete the row. Use condition(:expect_not_exist) , expect the primary_keys to row is not existed. for put_row/5 , if the primary keys have auto increment type, while the target primary keys row is existed, only use condition(:expect_exist) can successfully put the row; while the target primary keys row is not existed, only use condition(:ignore) can successfully put the row. Use condition(:ignore) , ignore the row existence check for put_row/5 , if the primary keys have auto increment column type, meanwhile the target primary keys row is not existed, only use condition(:ignore) can successfully put the row. for update_row/4 , if the primary keys have auto increment column type, meanwhile the target primary keys row is not existed, only use condition(:ignore) can successfully update the row. for delete_row/4 , no matter what primary keys type are, use condition(:ignore) can successfully delete the row if existed. The batch_write/3 operation is a collection of put_row / update_row / delete_row operations.","ref":"ExAliyunOts.html#condition/1","title":"ExAliyunOts.condition/1","type":"macro"},{"doc":"Similar to condition/1 and support use filter expression (please see filter/1 ) as well, please refer them for details. Example import MyApp.TableStore delete_row &quot;table&quot; , [ { &quot;key&quot; , &quot;key1&quot; } , { &quot;key2&quot; , &quot;key2&quot; } ] , condition : condition ( :expect_exist , &quot;attr_column&quot; == &quot;value2&quot; )","ref":"ExAliyunOts.html#condition/2","title":"ExAliyunOts.condition/2","type":"macro"},{"doc":"Create global secondary indexes. Official document in Chinese | English Example create_index &quot;table_name&quot; , &quot;table_index_name1&quot; [ &quot;pk1&quot; , &quot;pk2&quot; , &quot;col0&quot; ] , [ &quot;col1&quot; , &quot;col2&quot; ] create_index &quot;table_name&quot; , &quot;table_index_name2&quot; [ &quot;col0&quot; , &quot;pk1&quot; ] , [ &quot;col1&quot; , &quot;col2&quot; , &quot;col3&quot; ] , include_base_data : false Options :index_update_mode , the update mode of the index table, optional, currently only support :IUM_ASYNC_INDEX , by default it is :IUM_ASYNC_INDEX ; :index_type , the type of the index table, optional, currently only support :IT_GLOBAL_INDEX , by default it is :IT_GLOBAL_INDEX ; :include_base_data , specifies whether the index table includes the existing data in the base table, if set it to true means the index includes the existing data, if set it to false means the index excludes the existing data, optional, by default it is true .","ref":"ExAliyunOts.html#create_index/6","title":"ExAliyunOts.create_index/6","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore create_search_index &quot;table&quot; , &quot;index_name&quot; , field_schemas : [ field_schema_keyword ( &quot;name&quot; ) , field_schema_integer ( &quot;age&quot; ) ] create_search_index &quot;table&quot; , &quot;index_name&quot; , field_schemas : [ field_schema_keyword ( &quot;name&quot; ) , field_schema_geo_point ( &quot;location&quot; ) , field_schema_integer ( &quot;value&quot; ) ] create_search_index &quot;table&quot; , &quot;index_name&quot; , field_schemas : [ field_schema_nested ( &quot;content&quot; , field_schemas : [ field_schema_keyword ( &quot;header&quot; ) , field_schema_keyword ( &quot;body&quot; ) ] ) ] Options :field_schemas , required, a list of predefined search-index schema fields, please see the following helper functions: ExAliyunOts.Search.field_schema_integer/2 ExAliyunOts.Search.field_schema_float/2 ExAliyunOts.Search.field_schema_boolean/2 ExAliyunOts.Search.field_schema_keyword/2 ExAliyunOts.Search.field_schema_text/2 ExAliyunOts.Search.field_schema_nested/2 ExAliyunOts.Search.field_schema_geo_point/2 :index_sorts , optional, a list of predefined sort-index schema fields, please see the following helper functions: ExAliyunOts.Search.pk_sort/1 ExAliyunOts.Search.field_sort/2 ExAliyunOts.Search.geo_distance_sort/3","ref":"ExAliyunOts.html#create_search_index/4","title":"ExAliyunOts.create_search_index/4","type":"function"},{"doc":"Official document in Chinese | English Example create_table &quot;table_name2&quot; , [ { &quot;key1&quot; , :string } , { &quot;key2&quot; , :auto_increment } ] create_table &quot;table_name3&quot; , [ { &quot;key1&quot; , :string } ] , reserved_throughput_write : 1 , reserved_throughput_read : 1 , time_to_live : 100_000 , max_versions : 3 , deviation_cell_version_in_sec : 6_400 , stream_spec : [ is_enabled : true , expiration_time : 2 ] create_table &quot;table_name&quot; , [ { &quot;key1&quot; , :string } ] , defined_columns : [ { &quot;attr1&quot; , :string } , { &quot;attr2&quot; , :integer } , { &quot;attr3&quot; , :boolean } , { &quot;attr4&quot; , :double } , { &quot;attr5&quot; , :binary } ] create_table &quot;table_name&quot; , [ { &quot;key1&quot; , :string } ] , index_metas : [ { &quot;indexname1&quot; , [ &quot;key1&quot; ] , [ &quot;attr1&quot; , &quot;attr2&quot; ] } , { &quot;indexname2&quot; , [ &quot;key1&quot; ] , [ &quot;attr4&quot; ] } ] Options :reserved_throughput_write , optional, the reserved throughput write of table, by default it is 0. :reserved_throughput_read , optional, the reserved throughput read of table, by default it is 0. time_to_live , optional, the data storage time to live in seconds, the minimum settable value is 864_000 seconds (one day), by default it is -1 (for permanent). :max_versions , optional, the version of table, by default it is 1 that specifies there is only one version for columns. :deviation_cell_version_in_sec , optional, maximum version deviation, by default it is 864_000 seconds (one day). :stream_spec , specifies whether enable stream, by default it is not enable stream feature. :is_enabled , enable or not enable stream, use true or false ; :expiration_time , the expiration time of stream. :index_metas , optional, the index meta of table, each item of :index_metas is in {String.t(), list(), list()} format, by default it is []. :defined_columns , optional, the indexed attribute column, which is a combination of predefined columns of the base table, each item of :defined_columns is in {String.t(), :integer | :double | :boolean | :string | :binary} format, by default it is [].","ref":"ExAliyunOts.html#create_table/4","title":"ExAliyunOts.create_table/4","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore delete_index ( &quot;table_name&quot; , &quot;index_name&quot; )","ref":"ExAliyunOts.html#delete_index/3","title":"ExAliyunOts.delete_index/3","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore delete_row &quot;table1&quot; , [ { &quot;key1&quot; , 3 } , { &quot;key2&quot; , &quot;3&quot; } ] , condition : condition ( :expect_exist , &quot;attr2&quot; == &quot;value2&quot; ) delete_row &quot;table1&quot; , [ { &quot;key1&quot; , 3 } , { &quot;key2&quot; , &quot;3&quot; } ] , condition : condition ( :expect_exist , &quot;attr2&quot; == &quot;value2&quot; ) , transaction_id : &quot;transaction_id&quot; Options :condition , required, please see condition/1 or condition/2 for details. :transaction_id , optional, write operation within local transaction.","ref":"ExAliyunOts.html#delete_row/4","title":"ExAliyunOts.delete_row/4","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore delete_search_index ( &quot;table&quot; , &quot;index_name&quot; )","ref":"ExAliyunOts.html#delete_search_index/3","title":"ExAliyunOts.delete_search_index/3","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore delete_table ( &quot;table_name&quot; )","ref":"ExAliyunOts.html#delete_table/2","title":"ExAliyunOts.delete_table/2","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore describe_search_index ( &quot;table&quot; , &quot;index_name&quot; )","ref":"ExAliyunOts.html#describe_search_index/3","title":"ExAliyunOts.describe_search_index/3","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore describe_table ( table_name )","ref":"ExAliyunOts.html#describe_table/2","title":"ExAliyunOts.describe_table/2","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore get_row table_name1 , [ { &quot;key&quot; , &quot;key1&quot; } ] , columns_to_get : [ &quot;name&quot; , &quot;level&quot; ] , filter : filter ( ( { &quot;name&quot; , ignore_if_missing : true , latest_version_only : true } == var_name and &quot;age&quot; &gt; 1 ) or ( &quot;class&quot; == &quot;1&quot; ) ) batch_get [ get ( table_name2 , [ { &quot;key&quot; , &quot;key1&quot; } ] , filter : filter &quot;age&quot; &gt;= 10 ) ] Options ignore_if_missing , used when attribute column not existed. if a attribute column is not existed, when set ignore_if_missing: true in filter expression, there will ignore this row data in the returned result; if a attribute column is existed, the returned result won't be affected no matter true or false was set. latest_version_only , used when attribute column has multiple versions. if set latest_version_only: true , there will only check the value of the latest version is matched or not, by default it's set as latest_version_only: true ; if set latest_version_only: false , there will check the value of all versions are matched or not.","ref":"ExAliyunOts.html#filter/1","title":"ExAliyunOts.filter/1","type":"macro"},{"doc":"Used in batch get operation, please see batch_get/2 for details. Options The available options are same as get_row/4 .","ref":"ExAliyunOts.html#get/3","title":"ExAliyunOts.get/3","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore get_range &quot;table_name&quot; , [ { &quot;key1&quot; , 1 } , { &quot;key2&quot; , :inf_min } ] , [ { &quot;key1&quot; , 4 } , { &quot;key2&quot; , :inf_max } ] , direction : :forward get_range &quot;table_name&quot; , [ { &quot;key1&quot; , 1 } , { &quot;key2&quot; , :inf_min } ] , [ { &quot;key1&quot; , 4 } , { &quot;key2&quot; , :inf_max } ] , time_range : { 1525922253224 , 1525923253224 } , direction : :forward get_range &quot;table_name&quot; , [ { &quot;key1&quot; , 1 } , { &quot;key2&quot; , :inf_min } ] , [ { &quot;key1&quot; , 4 } , { &quot;key2&quot; , :inf_max } ] , time_range : 1525942123224 , direction : :forward Also, there is an alternative stream_range/5 to iteratively get range of rows in stream. Options :direction , required, the order of fetch data, available options are :forward | :backward , by it is :forward . :forward , this query is performed in the order of primary key in ascending, in this case, input inclusive_start_primary_keys should less than exclusive_end_primary_keys ; :backward , this query is performed in the order of primary key in descending, in this case, input inclusive_start_primary_keys should greater than exclusive_end_primary_keys . :columns_to_get , optional, fetch the special fields, by default it returns all fields, pass a field list to specify the expected return fields, e.g. [&quot;field1&quot;, &quot;field2&quot;] . :start_column , optional, specifies the start column when using for wide-row-read, the returned result contains this :start_column . :end_column , optional, specifies the end column when using for wide-row-read, the returned result does not contain this :end_column . :filter , optional, filter the return results in the server side, please see filter/1 for details. :max_versions , optional, how many versions need to return in results, by default it is 1. :transaction_id , optional, read operation within local transaction. :limit , optional, the maximum number of rows of data to be returned, this value must be greater than 0, whether this option is set or not, there returns a maximum of 5,000 data rows and the total data size never exceeds 4 MB. :time_range , optional, read data by timestamp range, support two ways to use it: time_range: {start_timestamp, end_timestamp} , the timestamp in the range (include start_timestamp but exclude end_timestamp ) and then will return in the results. time_range: special_timestamp , exactly match and then will return in the results. :time_range and :max_versions are mutually exclusive, by default use max_versions: 1 and time_range: nil .","ref":"ExAliyunOts.html#get_range/5","title":"ExAliyunOts.get_range/5","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore get_row &quot;table1&quot; , [ { &quot;key1&quot; , &quot;id1&quot; } , { &quot;key2&quot; , &quot;id2&quot; } ] , columns_to_get : [ &quot;name&quot; , &quot;level&quot; ] , filter : filter ( ( &quot;name[ignore_if_missing: true, latest_version_only: true]&quot; == var_name and &quot;age&quot; &gt; 1 ) or ( &quot;class&quot; == &quot;1&quot; ) ) get_row &quot;table2&quot; , [ { &quot;key&quot; , &quot;1&quot; } ] , start_column : &quot;room&quot; , filter : pagination ( offset : 0 , limit : 3 ) get_row &quot;table3&quot; , [ { &quot;key&quot; , &quot;1&quot; } ] , transaction_id : &quot;transaction_id&quot; Options :columns_to_get , optional, fetch the special fields, by default it returns all fields, pass a field list to specify the expected return fields e.g. [&quot;field1&quot;, &quot;field2&quot;] . :start_column , optional, specifies the start column when using for wide-row-read, the returned result contains this :start_column . :end_column , optional, specifies the end column when using for wide-row-read, the returned result does not contain this :end_column . :filter , optional, filter the return results in the server side, please see filter/1 for details. :max_versions , optional, how many versions need to return in results, by default it is 1. :time_range , optional, read data by timestamp range, support two ways to use it: time_range: {start_timestamp, end_timestamp} , the timestamp in the range (include start_timestamp but exclude end_timestamp ) and then will return in the results. time_range: special_timestamp , exactly match and then will return in the results. :time_range and :max_versions are mutually exclusive, by default use max_versions: 1 and time_range: nil . :transaction_id , optional, read operation within local transaction.","ref":"ExAliyunOts.html#get_row/4","title":"ExAliyunOts.get_row/4","type":"function"},{"doc":"As a wrapper built on get_range/5 to fetch a full matched data set by iterate, if process a large items, recommend to use stream_range/5 . Example import MyApp.TableStore iterate_all_range table_name1 , [ { &quot;key1&quot; , 1 } , { &quot;key2&quot; , :inf_min } ] , [ { &quot;key1&quot; , 4 } , { &quot;key2&quot; , :inf_max } ] , direction : :forward Options Please see options of get_range/5 for details.","ref":"ExAliyunOts.html#iterate_all_range/5","title":"ExAliyunOts.iterate_all_range/5","type":"function"},{"doc":"A simple wrapper of stream_parallel_scan/4 to take care OTSSessionExpired error with retry, make parallel scan as a stream that applies the given function to the complete result of scan query. In general, recommend to use this function for the common use case of parallel scan. Options :scan_query , required, the main option to use query. :query , required, bind to the query functions, the same as query option of search/5 . :limit , optional, the limited size of query, defaults to 2000, the maximum value of limit is 2000. :columns_to_get , optional, fetch the special fields, by default it returns all fields of the search index, here are available options: :all_from_index , return all attribute column fields of search index; :none , do not return any attribute column fields; [&quot;field1&quot;, &quot;field2&quot;] , specifies the expected return attribute column fields. :timeout , optional, the :timeout option of Task.async_stream/3 , defaults to :infinity . Example def iterate_stream ( stream ) do Enum . map ( stream , fn { :ok , response } -&gt; response { :error , error } -&gt; error end ) end iterate_parallel_scan ( &quot;table&quot; , &quot;index&quot; , &amp; iterate_stream / 1 , scan_query : [ query : match_query ( &quot;is_actived&quot; , &quot;true&quot; ) , limit : 1000 ] , columns_to_get : [ &quot;is_actived&quot; , &quot;name&quot; , &quot;score&quot; ] )","ref":"ExAliyunOts.html#iterate_parallel_scan/5","title":"ExAliyunOts.iterate_parallel_scan/5","type":"function"},{"doc":"A simple wrapper of stream_parallel_scan/4 to take care OTSSessionExpired error with retry, make parallel scan as a stream that applies the given function from module with the list of arguments args to the complete result of scan query. In general, recommend to use this function for the common use case of parallel scan. Options Please see options of iterate_parallel_scan/5 . Example defmodule StreamHandler do def iterate_stream ( stream ) do Enum . map ( stream , fn { :ok , response } -&gt; response { :error , error } -&gt; error end ) end end iterate_parallel_scan ( &quot;table&quot; , &quot;index&quot; , StreamHandler , :iterate_stream , [ ] , scan_query : [ query : match_query ( &quot;is_actived&quot; , &quot;true&quot; ) , limit : 1000 ] , columns_to_get : [ &quot;field1&quot; , &quot;field2&quot; ] )","ref":"ExAliyunOts.html#iterate_parallel_scan/7","title":"ExAliyunOts.iterate_parallel_scan/7","type":"function"},{"doc":"As a wrapper built on stream_search/4 to fetch a full matched data set as a stream, then use Enum.reduce/2 to iteratively format all data into a list, if process a large items, recommend to use stream_search/4 . Options Please see options of search/4 for details.","ref":"ExAliyunOts.html#iterate_search/4","title":"ExAliyunOts.iterate_search/4","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore list_search_index ( &quot;table&quot; )","ref":"ExAliyunOts.html#list_search_index/2","title":"ExAliyunOts.list_search_index/2","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore list_table ( )","ref":"ExAliyunOts.html#list_table/1","title":"ExAliyunOts.list_table/1","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore get_row table_name , [ { &quot;key&quot; , &quot;1&quot; } ] , start_column : &quot;room&quot; , filter : pagination ( offset : 0 , limit : 3 ) Use pagination/1 for :filter options when get row.","ref":"ExAliyunOts.html#pagination/1","title":"ExAliyunOts.pagination/1","type":"macro"},{"doc":"Leverage concurrent tasks to query matched raw data (still be with search function) more quickly, in this use case, this function is improved for speed up scan query, but no guarantee to the order of query results, and does not support the aggregation of scan query. In general, recommend to use iterate_parallel_scan/5 or iterate_parallel_scan/7 for the common use case of parallel scan. Official document in Chinese | English Options :scan_query , required, the main option to use query. :query , required, bind to the query functions, the same as query option of search/4 . :limit , optional, the limited size of query, defaults to 2000, the maximum value of limit is 2000. :token , optional, when do not load all the matched rows in a single request, there will return a next_token value in that result, and then we can pass it to :token in the next same scan query to continue load the rest rows. :max_parallel , required, the maximum number of concurrent, as the splits_size value from the response of compute_splits/3 . :current_parallel_id , required, refer the official document, the available value is in [0, max_parallel). :columns_to_get , optional, fetch the special fields, by default it returns all fields of the search index, here are available options: :all_from_index , return all attribute column fields of search index; :none , do not return any attribute column fields; [&quot;field1&quot;, &quot;field2&quot;] , specifies the expected return attribute column fields. session_id , as usual, this option is required from the response of compute_splits/3 , if not set this option, the query result may contain duplicate data, refer the official document, once occurs an OTSSessionExpired error, must initiate another parallel scan task to re-query data.","ref":"ExAliyunOts.html#parallel_scan/4","title":"ExAliyunOts.parallel_scan/4","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore put_row &quot;table1&quot; , [ { &quot;key1&quot; , &quot;id1&quot; } ] , [ { &quot;name&quot; , &quot;name1&quot; } , { &quot;age&quot; , 20 } ] , condition : condition ( :expect_not_exist ) , return_type : :pk put_row &quot;table2&quot; , [ { &quot;key1&quot; , &quot;id1&quot; } ] , [ { &quot;name&quot; , &quot;name1&quot; } , { &quot;age&quot; , 20 } ] , condition : condition ( :expect_not_exist ) , transaction_id : &quot;transaction_id&quot; return_type : :pk Options :condition , required, please see condition/1 or condition/2 for details. :return_type , optional, whether return the primary keys after put row, available options are :pk | :none , by default it is :none . :transaction_id , optional, write operation within local transaction.","ref":"ExAliyunOts.html#put_row/5","title":"ExAliyunOts.put_row/5","type":"function"},{"doc":"The one entrance to use search index functions, please see ExAliyunOts.Search module for details. Official document in Chinese | English Options :search_query , required, the main option to use query and sort. :query , required, bind to the query functions: ExAliyunOts.Search.bool_query/1 ExAliyunOts.Search.exists_query/1 ExAliyunOts.Search.geo_bounding_box_query/3 ExAliyunOts.Search.geo_distance_query/3 ExAliyunOts.Search.geo_polygon_query/2 ExAliyunOts.Search.match_all_query/0 ExAliyunOts.Search.match_phrase_query/2 ExAliyunOts.Search.match_query/3 ExAliyunOts.Search.nested_query/3 ExAliyunOts.Search.prefix_query/2 ExAliyunOts.Search.range_query/2 ExAliyunOts.Search.term_query/2 ExAliyunOts.Search.terms_query/2 ExAliyunOts.Search.wildcard_query/2 :sort , optional, by default it is use pk_sort/1 , bind to the Sort functions: ExAliyunOts.Search.field_sort/2 ExAliyunOts.Search.geo_distance_sort/3 ExAliyunOts.Search.nested_filter/2 ExAliyunOts.Search.pk_sort/1 ExAliyunOts.Search.score_sort/1 :aggs , optional, please see official document in Chinese | English . :group_bys , optional, please see official document in Chinese | English . :limit , optional, the limited size of query. :offset , optional, the offset size of query. When the total rows are less or equal than 2000, can both used :limit and :offset to pagination. :get_total_count , optional, return the total count of the all matched rows, by default it is true . :token , optional, when do not load all the matched rows in a single request, there will return a next_token value in that result, and then we can pass it to :token in the next same search query to continue load the rest rows. :collapse , optional, duplicate removal by the specified field, please see official document in Chinese , please NOTICE that currently there does not support use :collapse with :token together. :columns_to_get , optional, fetch the special fields, by default it returns all fields, here are available options: :all , return all attribute column fields; :none , do not return any attribute column fields; [&quot;field1&quot;, &quot;field2&quot;] , specifies the expected return attribute column fields.","ref":"ExAliyunOts.html#search/4","title":"ExAliyunOts.search/4","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore partition_key = { &quot;key&quot; , &quot;key1&quot; } start_local_transaction ( &quot;table&quot; , partition_key )","ref":"ExAliyunOts.html#start_local_transaction/3","title":"ExAliyunOts.start_local_transaction/3","type":"function"},{"doc":"Integrate parallel_scan/4 with compute_splits/3 as a complete use, base on the response of compute_splits/3 to create the corresponding number of concurrency task(s), use Task.async_stream/3 to make parallel scan as a stream which properly process token in every request of the internal, when use this function need to consider the possibility of the OTSSessionExpired error in the external. Options Please see options of iterate_parallel_scan/5 .","ref":"ExAliyunOts.html#stream_parallel_scan/4","title":"ExAliyunOts.stream_parallel_scan/4","type":"function"},{"doc":"As a wrapper built on get_range/5 to create composable and lazy enumerable stream for iteration. Example import MyApp.TableStore stream = stream_range table_name1 , [ { &quot;key1&quot; , 1 } , { &quot;key2&quot; , :inf_min } ] , [ { &quot;key1&quot; , 4 } , { &quot;key2&quot; , :inf_max } ] , direction : :forward Enum . to_list ( stream , fn { :ok , %{ rows : rows } = response } -&gt; # process rows { :error , error } -&gt; # occur error end ) Options Please see options of get_range/5 for details.","ref":"ExAliyunOts.html#stream_range/5","title":"ExAliyunOts.stream_range/5","type":"function"},{"doc":"As a wrapper built on search/4 to create composable and lazy enumerable stream for iteration. Options Please see options of search/4 for details.","ref":"ExAliyunOts.html#stream_search/4","title":"ExAliyunOts.stream_search/4","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore value = &quot;1&quot; update_row &quot;table1&quot; , [ { &quot;key1&quot; , 2 } , { &quot;key2&quot; , &quot;2&quot; } ] , delete : [ { &quot;attr2&quot; , nil , 1524464460 } ] , delete_all : [ &quot;attr1&quot; ] , put : [ { &quot;attr3&quot; , &quot;put_attr3&quot; } ] , return_type : :pk , condition : condition ( :expect_exist , &quot;attr2&quot; == value ) update_row &quot;table2&quot; , [ { &quot;key1&quot; , 1 } ] , put : [ { &quot;attr1&quot; , &quot;put_attr1&quot; } ] , increment : [ { &quot;count&quot; , 1 } ] , return_type : :after_modify , return_columns : [ &quot;count&quot; ] , condition : condition ( :ignore ) update_row &quot;table3&quot; , [ partition_key ] , put : [ { &quot;new_attr1&quot; , &quot;a1&quot; } ] , delete_all : [ &quot;level&quot; , &quot;size&quot; ] , condition : condition ( :ignore ) , transaction_id : &quot;transaction_id&quot; Options :put , optional, require to be valid value, e.g. [{&quot;field1&quot;, &quot;value&quot;}, {...}] , insert a new column if this field is not existed, or overwrite this field if existed. :delete , optional, delete the special version of a column or columns, please pass the column's version (timestamp) in :delete option, e.g. [{&quot;field1&quot;, nil, 1524464460}, ...]. :delete_all , optional, delete all versions of a column or columns, e.g. [&quot;field1&quot;, &quot;field2&quot;, ...]. :increment , optional, attribute column(s) base on atomic counters for increment or decrement, require the value of column is integer. for increment, increment: [{&quot;count&quot;, 1}] ; for decrement, increment: [{&quot;count&quot;, -1}] . :return_type , optional, whether return the primary keys after update row, available options are :pk | :none | :after_modify , by default it is :none . if use atomic counters, must set return_type: :after_modify . :condition , required, please see condition/1 or condition/2 for details. :transaction_id , optional, write operation within local transaction.","ref":"ExAliyunOts.html#update_row/4","title":"ExAliyunOts.update_row/4","type":"function"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore update_table &quot;table_name&quot; , reserved_throughput_write : 10 , time_to_live : 200_000 , stream_spec : [ is_enabled : false ] Options Please see options of create_table/4 .","ref":"ExAliyunOts.html#update_table/3","title":"ExAliyunOts.update_table/3","type":"function"},{"doc":"Used in batch write operation, please see batch_write/2 for details. Options The available operation same as delete_row/4 .","ref":"ExAliyunOts.html#write_delete/2","title":"ExAliyunOts.write_delete/2","type":"function"},{"doc":"Used in batch write operation, please see batch_write/2 for details. Options The available options are same as put_row/5 .","ref":"ExAliyunOts.html#write_put/3","title":"ExAliyunOts.write_put/3","type":"function"},{"doc":"Used in batch write operation, please see batch_write/2 for details. Options The available options are same as update_row/4 .","ref":"ExAliyunOts.html#write_update/2","title":"ExAliyunOts.write_update/2","type":"function"},{"doc":"","ref":"ExAliyunOts.html#t:exclusive_end_primary_keys/0","title":"ExAliyunOts.exclusive_end_primary_keys/0","type":"type"},{"doc":"","ref":"ExAliyunOts.html#t:inclusive_start_primary_keys/0","title":"ExAliyunOts.inclusive_start_primary_keys/0","type":"type"},{"doc":"","ref":"ExAliyunOts.html#t:index_name/0","title":"ExAliyunOts.index_name/0","type":"type"},{"doc":"","ref":"ExAliyunOts.html#t:instance/0","title":"ExAliyunOts.instance/0","type":"type"},{"doc":"","ref":"ExAliyunOts.html#t:options/0","title":"ExAliyunOts.options/0","type":"type"},{"doc":"","ref":"ExAliyunOts.html#t:primary_keys/0","title":"ExAliyunOts.primary_keys/0","type":"type"},{"doc":"","ref":"ExAliyunOts.html#t:result/0","title":"ExAliyunOts.result/0","type":"type"},{"doc":"","ref":"ExAliyunOts.html#t:row_existence/0","title":"ExAliyunOts.row_existence/0","type":"type"},{"doc":"","ref":"ExAliyunOts.html#t:table_name/0","title":"ExAliyunOts.table_name/0","type":"type"},{"doc":"","ref":"ExAliyunOts.DSL.html","title":"ExAliyunOts.DSL","type":"module"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore update_row &quot;table&quot; , [ { &quot;pk&quot; , &quot;pk1&quot; } ] , delete_all : [ &quot;attr1&quot; , &quot;attr2&quot; ] , return_type : :pk , condition : condition ( :expect_exist ) The available existence options: :expect_exist | :expect_not_exist | :ignore , here are some use cases for your reference: Use condition(:expect_exist) , expect the primary keys to row is existed. for put_row/5 , if the primary keys have auto increment column type, meanwhile the target primary keys row is existed, only use condition(:expect_exist) can successfully overwrite the row. for update_row/4 , if the primary keys have auto increment column type, meanwhile the target primary keys row is existed, only use condition(:expect_exist) can successfully update the row. for delete_row/4 , no matter what primary keys type are, use condition(:expect_exist) can successfully delete the row. Use condition(:expect_not_exist) , expect the primary_keys to row is not existed. for put_row/5 , if the primary keys have auto increment type, while the target primary keys row is existed, only use condition(:expect_exist) can successfully put the row; while the target primary keys row is not existed, only use condition(:ignore) can successfully put the row. Use condition(:ignore) , ignore the row existence check for put_row/5 , if the primary keys have auto increment column type, meanwhile the target primary keys row is not existed, only use condition(:ignore) can successfully put the row. for update_row/4 , if the primary keys have auto increment column type, meanwhile the target primary keys row is not existed, only use condition(:ignore) can successfully update the row. for delete_row/4 , no matter what primary keys type are, use condition(:ignore) can successfully delete the row if existed. The batch_write/3 operation is a collection of put_row / update_row / delete_row operations.","ref":"ExAliyunOts.DSL.html#condition/1","title":"ExAliyunOts.DSL.condition/1","type":"macro"},{"doc":"Similar to condition/1 and support use filter expression (please see filter/1 ) as well, please refer them for details. Example import MyApp.TableStore delete_row &quot;table&quot; , [ { &quot;key&quot; , &quot;key1&quot; } , { &quot;key2&quot; , &quot;key2&quot; } ] , condition : condition ( :expect_exist , &quot;attr_column&quot; == &quot;value2&quot; )","ref":"ExAliyunOts.DSL.html#condition/2","title":"ExAliyunOts.DSL.condition/2","type":"macro"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore get_row table_name1 , [ { &quot;key&quot; , &quot;key1&quot; } ] , columns_to_get : [ &quot;name&quot; , &quot;level&quot; ] , filter : filter ( ( { &quot;name&quot; , ignore_if_missing : true , latest_version_only : true } == var_name and &quot;age&quot; &gt; 1 ) or ( &quot;class&quot; == &quot;1&quot; ) ) batch_get [ get ( table_name2 , [ { &quot;key&quot; , &quot;key1&quot; } ] , filter : filter &quot;age&quot; &gt;= 10 ) ] Options ignore_if_missing , used when attribute column not existed. if a attribute column is not existed, when set ignore_if_missing: true in filter expression, there will ignore this row data in the returned result; if a attribute column is existed, the returned result won't be affected no matter true or false was set. latest_version_only , used when attribute column has multiple versions. if set latest_version_only: true , there will only check the value of the latest version is matched or not, by default it's set as latest_version_only: true ; if set latest_version_only: false , there will check the value of all versions are matched or not.","ref":"ExAliyunOts.DSL.html#filter/1","title":"ExAliyunOts.DSL.filter/1","type":"macro"},{"doc":"Official document in Chinese | English Example import MyApp.TableStore get_row table_name , [ { &quot;key&quot; , &quot;1&quot; } ] , start_column : &quot;room&quot; , filter : pagination ( offset : 0 , limit : 3 ) Use pagination/1 for :filter options when get row.","ref":"ExAliyunOts.DSL.html#pagination/1","title":"ExAliyunOts.DSL.pagination/1","type":"macro"},{"doc":"","ref":"ExAliyunOts.DSL.html#t:row_existence/0","title":"ExAliyunOts.DSL.row_existence/0","type":"type"},{"doc":"Describe request error from server http response.","ref":"ExAliyunOts.Error.html","title":"ExAliyunOts.Error","type":"module"},{"doc":"","ref":"ExAliyunOts.Error.html#t:t/0","title":"ExAliyunOts.Error.t/0","type":"type"},{"doc":"Describe Alibaba TableStore instance primary information.","ref":"ExAliyunOts.Instance.html","title":"ExAliyunOts.Instance","type":"module"},{"doc":"","ref":"ExAliyunOts.Instance.html#t:t/0","title":"ExAliyunOts.Instance.t/0","type":"type"},{"doc":"Use the multiple efficient index schemas of search index to solve complex query problems. Here are links to the search section of Alibaba official document: Chinese | English To use ExAliyunOts , a module that calls use ExAliyunOts has to be defined: defmodule MyApp.Tablestore do use ExAliyunOts , instance : :my_instance end This automatically defines some search functions in MyApp.Tablestore module, we can use them as helpers when invoke MyApp.Tablestore.search/3 , here are some examples: import MyApp.Tablestore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : match_query ( &quot;age&quot; , 28 ) , sort : [ field_sort ( &quot;age&quot; , order : :desc ) ] ] search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : exists_query ( &quot;column_a&quot; ) , group_bys : [ group_by_field ( &quot;group_name&quot; , &quot;column_b&quot; , sub_group_bys : [ group_by_range ( &quot;group_name_1&quot; , &quot;column_d&quot; , [ { 0 , 10 } , { 10 , 20 } ] ) ] , sort : [ group_key_sort ( :desc ) ] ) , group_by_field ( &quot;group_name2&quot; , &quot;column_c&quot; ) ] , aggs : [ agg_min ( &quot;aggregation_name&quot; , &quot;column_e&quot; ) ] ] Please notice: The statistics(via :aggs ) and GroupBy type aggregations(via :group_bys ) can be used at the same time. The GroupBy type aggregations support the nested sub statistics(via :sub_aggs ) and sub GroupBy type aggregations(via :sub_group_bys ). To ensure the performance and reduce the complexity of aggregations, there is a limitation with a certain number of levels for nesting. If you are only care about using :aggs or :group_bys , meanwhile do not need the returned rows, you can set :limit as 0 to ignore the matched rows return, there will have a better query performance.","ref":"ExAliyunOts.Search.html","title":"ExAliyunOts.Search","type":"module"},{"doc":"Calculate the average value of the assigned field by aggregation in the nested :aggs option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , aggs : [ agg_avg ( &quot;agg_name&quot; , &quot;score&quot; ) ] ] The aggregation_name can be any business description string, when get the calculated results, we need to use it to fetch them. Options :missing , when the field is not existed in a row of data, if :missing is not set, the row will be ignored in statistics; if :missing is set, the row will use :missing value to participate in the statistics of average value, by default it's nil (not-set).","ref":"ExAliyunOts.Search.html#agg_avg/3","title":"ExAliyunOts.Search.agg_avg/3","type":"function"},{"doc":"Calculate the count of the assigned field by aggregation in the nested :aggs option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , aggs : [ agg_sum ( &quot;agg_name&quot; , &quot;score&quot; ) ] ] The aggregation_name can be any business description string, when get the calculated results, we need to use it to fetch them. If the field is not existed in a row of data, then this row does not participate in the statistics of count.","ref":"ExAliyunOts.Search.html#agg_count/2","title":"ExAliyunOts.Search.agg_count/2","type":"function"},{"doc":"Calculate the distinct count of the assigned field by aggregation in the nested :aggs option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , aggs : [ agg_distinct_count ( &quot;agg_name&quot; , &quot;score&quot; ) ] ] The aggregation_name can be any business description string, when get the calculated results, we need to use it to fetch them. Options :missing , when the field is not existed in a row of data, if :missing is not set, the row will be ignored in statistics; if :missing is set, the row will use :missing value to participate in the statistics of distinct count, by default it's nil (not-set).","ref":"ExAliyunOts.Search.html#agg_distinct_count/3","title":"ExAliyunOts.Search.agg_distinct_count/3","type":"function"},{"doc":"Calculate the maximum value of the assigned field by aggregation in the nested :aggs option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , aggs : [ agg_max ( &quot;agg_name&quot; , &quot;score&quot; ) ] ] The aggregation_name can be any business description string, when get the calculated results, we need to use it to fetch them. Options :missing , when the field is not existed in a row of data, if :missing is not set, the row will be ignored in statistics; if :missing is set, the row will use :missing value to participate in the statistics of maximum value, by default it's nil (not-set).","ref":"ExAliyunOts.Search.html#agg_max/3","title":"ExAliyunOts.Search.agg_max/3","type":"function"},{"doc":"Calculate the minimum value of the assigned field by aggregation in the nested :aggs option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , aggs : [ agg_min ( &quot;agg_name&quot; , &quot;score&quot; ) ] ] The aggregation_name can be any business description string, when get the calculated results, we need to use it to fetch them. Options :missing , when the field is not existed in a row of data, if :missing is not set, the row will be ignored in statistics; if :missing is set, the row will use :missing value to participate in the statistics of minimum value, by default it's nil (not-set).","ref":"ExAliyunOts.Search.html#agg_min/3","title":"ExAliyunOts.Search.agg_min/3","type":"function"},{"doc":"Calculate the summation of the assigned field by aggregation in the nested :aggs option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , aggs : [ agg_sum ( &quot;agg_name&quot; , &quot;score&quot; ) ] ] The aggregation_name can be any business description string, when get the calculated results, we need to use it to fetch them. Options :missing , when the field is not existed in a row of data, if :missing is not set, the row will be ignored in statistics; if :missing is set, the row will use :missing value to participate in the statistics of summation value, by default it's nil (not-set).","ref":"ExAliyunOts.Search.html#agg_sum/3","title":"ExAliyunOts.Search.agg_sum/3","type":"function"},{"doc":"Use BoolQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : bool_query ( must : range_query ( &quot;age&quot; , from : 20 , to : 32 ) , must_not : term_query ( &quot;age&quot; , 28 ) ) ] The following options can be a single Query or a list of Query to combine the &quot;And | Or | At least&quot; search condition. Options :must , specifies the Queries that the query result must match, this option is equivalent to the AND operator. :must_not , specifies the Queries that the query result must not match, this option is equivalent to the NOT operator. :should , specifies the Queries that the query result may or may not match, this option is equivalent to the OR operator. :minimum_should_match , specifies the minimum number of :should that the query result must match.","ref":"ExAliyunOts.Search.html#bool_query/1","title":"ExAliyunOts.Search.bool_query/1","type":"function"},{"doc":"Use ExistsQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : exists_query ( &quot;values&quot; ) ]","ref":"ExAliyunOts.Search.html#exists_query/1","title":"ExAliyunOts.Search.exists_query/1","type":"function"},{"doc":"Official document in Chinese | English Example field_schema_boolean ( &quot;status&quot; ) Options :index , specifies whether to set as index, by default it is true; :enable_sort_and_agg , specifies whether to support sort and statistics, by default it is true; :store , specifies whether to store the origin value in search index for a better read performance, by default it is true; :is_array , specifies whether the stored data is a JSON encoded list as a string, e.g. &quot;[false,true,false]&quot; .","ref":"ExAliyunOts.Search.html#field_schema_boolean/2","title":"ExAliyunOts.Search.field_schema_boolean/2","type":"function"},{"doc":"Official document in Chinese | English Example field_schema_float ( &quot;price&quot; ) Options :index , specifies whether to set as index, by default it is true; :enable_sort_and_agg , specifies whether to support sort and statistics, by default it is true; :store , specifies whether to store the origin value in search index for a better read performance, by default it is true; :is_array , specifies whether the stored data is a JSON encoded list as a string, e.g. &quot;[1.0,2.0]&quot; .","ref":"ExAliyunOts.Search.html#field_schema_float/2","title":"ExAliyunOts.Search.field_schema_float/2","type":"function"},{"doc":"Official document in Chinese | English Example field_schema_geo_point ( &quot;location&quot; ) Options :index , specifies whether to set as index, by default it is true; :enable_sort_and_agg , specifies whether to support sort and statistics, by default it is true; :store , specifies whether to store the origin value in search index for a better read performance, by default it is true; :is_array , specifies whether the stored data is a JSON encoded list as a string, e.g. &quot;[&quot;10.21,10&quot;,&quot;10.31,9.98&quot;]&quot; .","ref":"ExAliyunOts.Search.html#field_schema_geo_point/2","title":"ExAliyunOts.Search.field_schema_geo_point/2","type":"function"},{"doc":"Official document in Chinese | English Example field_schema_integer ( &quot;age&quot; ) Options :index , specifies whether to set as index, by default it is true; :enable_sort_and_agg , specifies whether to support sort and statistics, by default it is true; :store , specifies whether to store the origin value in search index for a better read performance, by default it is true; :is_array , specifies whether the stored data is a JSON encoded list as a string, e.g. &quot;[1,2]&quot; .","ref":"ExAliyunOts.Search.html#field_schema_integer/2","title":"ExAliyunOts.Search.field_schema_integer/2","type":"function"},{"doc":"Official document in Chinese | English Example field_schema_keyword ( &quot;status&quot; ) Options :index , specifies whether to set as index, by default it is true; :enable_sort_and_agg , specifies whether to support sort and statistics, by default it is true; :store , specifies whether to store the origin value in search index for a better read performance, by default it is true; :is_array , specifies whether the stored data is a JSON encoded list as a string, e.g. &quot;[&quot;a&quot;,&quot;b&quot;]&quot; .","ref":"ExAliyunOts.Search.html#field_schema_keyword/2","title":"ExAliyunOts.Search.field_schema_keyword/2","type":"function"},{"doc":"Official document in Chinese | English Example field_schema_nested ( &quot;content&quot; , field_schemas : [ field_schema_keyword ( &quot;header&quot; ) , field_schema_keyword ( &quot;body&quot; ) , ] Options :field_schemas , required, the nested field schema(s); :index , specifies whether to set as index, by default it is true; :store , specifies whether to store the origin value in search index for a better read performance, by default it is true; :enable_sort_and_agg , specifies whether to support sort and statistics, by default it is true.","ref":"ExAliyunOts.Search.html#field_schema_nested/2","title":"ExAliyunOts.Search.field_schema_nested/2","type":"function"},{"doc":"Official document in Chinese | English Example field_schema_text ( &quot;content&quot; ) Options :index , specifies whether to set as index, by default it is true; :store , specifies whether to store the origin value in search index for a better read performance, by default it is true; :is_array , specifies whether the stored data is a JSON encoded list as a string, e.g. &quot;[&quot;a&quot;,&quot;b&quot;]&quot; . :analyzer , optional, please see analyzer document in Chinese | English .","ref":"ExAliyunOts.Search.html#field_schema_text/2","title":"ExAliyunOts.Search.field_schema_text/2","type":"function"},{"doc":"Sort by the value of a column, use it in the nested :sort option of :search_query option in ExAliyunOts.search/4 . Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , sort : [ field_sort ( &quot;field_a&quot; , order : :desc ) ] ] If there's a nested type of search index, and they are a integer or float list, we can use :mode to sort according to the minimum/maximum/average value of the list, by default it's :nil . For example, there's a nested type as &quot;values&quot; field, the following query will find &quot;values&quot; field existed as matched rows, and sort by the minimum value of list items. Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : exists_query ( &quot;values&quot; ) , sort : [ field_sort ( &quot;values&quot; , mode : :min ) ] ] Still for nested type of search index, we can sort by the nested value via :nested_filter option, for example, sort by the value of &quot;content.header&quot; in :desc order. Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : nested_query ( &quot;content&quot; , [ exists_query ( &quot;content.header&quot; ) ] ) , sort : [ field_sort ( &quot;content.header&quot; , order : :desc , nested_filter : nested_filter ( &quot;content&quot; , prefix_query ( &quot;content.header&quot; , &quot;header&quot; ) ) ) ] ] Please ensure that the query criteria matched will participate in sorting, if there exists any not matched case will lead to uncertainty of sorting results. Options :mode , optional, available options are :min | :max | :avg , by default it's :nil ; :order , optional, available options are :asc | :desc , by default it's :asc ; :nested_filter , optional, see nested_filter/2 for details.","ref":"ExAliyunOts.Search.html#field_sort/2","title":"ExAliyunOts.Search.field_sort/2","type":"function"},{"doc":"Use GeoBoundingBoxQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : geo_bounding_box_query ( &quot;location&quot; , &quot;10,-10&quot; , &quot;-10,10&quot; ) ] Please notice that all geographic coordinates are in &quot;$latitude,$longitude&quot; format.","ref":"ExAliyunOts.Search.html#geo_bounding_box_query/3","title":"ExAliyunOts.Search.geo_bounding_box_query/3","type":"function"},{"doc":"Use GeoDistanceQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : geo_distance_query ( &quot;location&quot; , 500_000 , &quot;5,5&quot; ) ] Please notice that all geographic coordinates are in &quot;$latitude,$longitude&quot; format.","ref":"ExAliyunOts.Search.html#geo_distance_query/3","title":"ExAliyunOts.Search.geo_distance_query/3","type":"function"},{"doc":"Geographic distance sorting, according to the sum of distances between to the input geographical points, sort by the minimum/maximum/average summation value. Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : geo_distance_query ( &quot;location&quot; , 500_000 , &quot;5,5&quot; ) , sort : [ geo_distance_sort ( &quot;location&quot; , [ &quot;5.14,5.21&quot; ] , order : :asc ) ] ] The input points are a list of string, each format as &quot;$latitude,$longitude&quot;. Options :order , optional, available options are :asc | :desc ; :mode , optional, used for nested type field within integer or float, as :min will sort by the minimum value of items, as :max will sort by the maximum value of items, as :avg will sort by the average value of items, by default it's :nil ; :distance_type , optional, available options are :arc | :plane , as :arc means distance calculated by arc surface, as :plane means distance calculated by plane.","ref":"ExAliyunOts.Search.html#geo_distance_sort/3","title":"ExAliyunOts.Search.geo_distance_sort/3","type":"function"},{"doc":"Use GeoPolygonQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : geo_polygon_query ( &quot;location&quot; , [ &quot;11,11&quot; , &quot;0,0&quot; , &quot;1,5&quot; ] ) ] Please notice that all geographic coordinates are in &quot;$latitude,$longitude&quot; format.","ref":"ExAliyunOts.Search.html#geo_polygon_query/2","title":"ExAliyunOts.Search.geo_polygon_query/2","type":"function"},{"doc":"The :group_bys results are grouped according to the value of a field, the same value will be put into a group, finally, the value of each group and the number corresponding to the value will be returned. We can set it in the nested :group_bys option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , group_bys : [ group_by_field ( &quot;group_name&quot; , &quot;type&quot; , size : 3 , sub_group_bys : [ group_by_field ( &quot;sub_gn1&quot; , &quot;is_actived&quot; ) ] , sort : [ row_count_sort ( :asc ) , group_key_sort ( :desc ) ] ) , group_by_field ( &quot;group_name2&quot; , &quot;is_actived&quot; ) ] ] The group_name can be any business description string, when get the grouped results, we need to use it to fetch them. Options :sort , optional, add sorting rules for items in a group, by default, sort in descending order according to the quantity of items in the group. Support group_key_sort/1 | row_count_sort/1 | sub_agg_sort/2 sort. :size , optional, the number of returned groups. :sub_group_bys , optional, add sub GroupBy type aggregations. :sub_aggs , optional, add sub statistics.","ref":"ExAliyunOts.Search.html#group_by_field/3","title":"ExAliyunOts.Search.group_by_field/3","type":"function"},{"doc":"On the query results, group by filters (they're Query usecase), and then get the number of matched filters, the order of the returned results is the same as that of the added filter(s). We can set it in the nested :group_bys option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , group_bys : [ group_by_filter ( &quot;group_name&quot; , [ term_query ( &quot;is_actived&quot; , true ) , range_query ( &quot;price&quot; , from : 50 ) ] ) ] ] Options :sub_group_bys , optional, add sub GroupBy type aggregations. :sub_aggs , optional, add sub statistics.","ref":"ExAliyunOts.Search.html#group_by_filter/3","title":"ExAliyunOts.Search.group_by_filter/3","type":"function"},{"doc":"The query results are grouped according to the range from a certain center Geo point, if the distance difference is within a certain range, it will be put into a group, and finally the number of corresponding items in each range will be returned. We can set it in the nested :group_bys option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , group_bys : [ group_by_geo_distance ( &quot;test&quot; , &quot;location&quot; , [ { 0 , 100_000 } , { 100_000 , 500_000 } , { 500_000 , 1000_000 } , ] , lon : 0 , lat : 0 , sub_aggs : [ agg_sum ( &quot;test_sum&quot; , &quot;value&quot; ) ] ) ] ] Options :lon , required, the longitude of the origin center point, integer or float. :lat , required, the latitude of the origin center point, integer or float. :sub_group_bys , optional, add sub GroupBy type aggregations. :sub_aggs , optional, add sub statistics.","ref":"ExAliyunOts.Search.html#group_by_geo_distance/4","title":"ExAliyunOts.Search.group_by_geo_distance/4","type":"function"},{"doc":"The :group_bys results are grouped according to the range of a field, if the field value is within a range, it will be put into a group, finally, the number corresponding to the value will be returned. We can set it in the nested :group_bys option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , group_bys : [ group_by_range ( &quot;group_name&quot; , &quot;price&quot; , [ { 0 , 18 } , { 18 , 50 } ] , sub_group_bys : [ group_by_field ( &quot;sorted_by_type&quot; , &quot;type&quot; , sort : [ group_key_sort ( :asc ) ] ) ] , sub_aggs : [ agg_distinct_count ( &quot;distinct_price&quot; , &quot;price&quot; ) ] ) ] ] The group_name can be any business description string, when get the grouped results, we need to use it to fetch them. Please notice that each range item(as a tuple, according to { from , to }) of ranges , its start is greater than or equal to from , and its ending is less than to , the range interval value can be integer or float. Options :sub_group_bys , optional, add sub GroupBy type aggregations. :sub_aggs , optional, add sub statistics.","ref":"ExAliyunOts.Search.html#group_by_range/4","title":"ExAliyunOts.Search.group_by_range/4","type":"function"},{"doc":"Use in group_by_field/3 scenario, in ascending/descending order of field literal. Official document in Chinese | English Example In the following example, the returned results will be sorted in descending order of the &quot;type&quot; field: import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , group_bys : [ group_by_field ( &quot;group_name&quot; , &quot;type&quot; , sub_group_bys : [ ... ] , sort : [ group_key_sort ( :desc ) ] ) ] ]","ref":"ExAliyunOts.Search.html#group_key_sort/1","title":"ExAliyunOts.Search.group_key_sort/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Search.html#map_scan_options/2","title":"ExAliyunOts.Search.map_scan_options/2","type":"function"},{"doc":"Use MatchAllQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : match_all_query ( ) ] Official document in Chinese | English","ref":"ExAliyunOts.Search.html#match_all_query/0","title":"ExAliyunOts.Search.match_all_query/0","type":"function"},{"doc":"Use MatchPhraseQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Similar to MatchQuery , however, the location relationship of multiple terms after word segmentation will be considered, multiple terms after word segmentation must exist in the same order and location in the row data to be hit this query. Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : match_phrase_query ( &quot;content&quot; , &quot;tablestore&quot; ) ]","ref":"ExAliyunOts.Search.html#match_phrase_query/2","title":"ExAliyunOts.Search.match_phrase_query/2","type":"function"},{"doc":"Use MatchQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : match_query ( &quot;age&quot; , 28 ) ] Official document in Chinese | English Options :minimum_should_match , the minimum number of terms that the value of the fieldName field in a row contains when Table Store returns this row in the query result, by default it's 1. :operator , the operator used in a logical operation, by default it's Or , it means that as long as several terms after the participle are partially hit, they are considered hit this query.","ref":"ExAliyunOts.Search.html#match_query/3","title":"ExAliyunOts.Search.match_query/3","type":"function"},{"doc":"Use for the nested type field in field_sort/2 as :nested_filter option, the input filter is a Query to filter results. Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : nested_query ( &quot;content&quot; , [ exists_query ( &quot;content.header&quot; ) ] ) , sort : [ field_sort ( &quot;content.header&quot; , order : :desc , nested_filter : nested_filter ( &quot;content&quot; , prefix_query ( &quot;content.header&quot; , &quot;header&quot; ) ) ) ] ] Please ensure that the query criteria matched will participate in sorting, if there exists any not matched case will lead to uncertainty of sorting results.","ref":"ExAliyunOts.Search.html#nested_filter/2","title":"ExAliyunOts.Search.nested_filter/2","type":"function"},{"doc":"Use NestedQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 , the target field need to be a nested type, it is used to query sub documents of nested type. Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : nested_query ( &quot;content&quot; , term_query ( &quot;content.header&quot; , &quot;header1&quot; ) ) ] Options :score_mode , available options have :none | :avg | :max | :total | :min , by default it's :none .","ref":"ExAliyunOts.Search.html#nested_query/3","title":"ExAliyunOts.Search.nested_query/3","type":"function"},{"doc":"Sort by the primary key(s) of row, use it in the nested :sort option of :search_query option in ExAliyunOts.search/4 . Each search request use this sort by default.","ref":"ExAliyunOts.Search.html#pk_sort/1","title":"ExAliyunOts.Search.pk_sort/1","type":"function"},{"doc":"Use PrefixQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : prefix_query ( &quot;name&quot; , &quot;n&quot; ) ]","ref":"ExAliyunOts.Search.html#prefix_query/2","title":"ExAliyunOts.Search.prefix_query/2","type":"function"},{"doc":"Use RangeQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : range_query ( &quot;score&quot; , from : 60 , to : 80 , include_upper : false , include_lower : false ) ] Options :from , the value of the start position. :to , the value of the end position. :include_lower , specifies whether to include the :from value in the result, available options are true | false , by default it's true . :include_upper , specifies whether to include the :to value in the result, available options are true | false , by default it's true .","ref":"ExAliyunOts.Search.html#range_query/2","title":"ExAliyunOts.Search.range_query/2","type":"function"},{"doc":"Use in group_by_field/3 scenario, in ascending/descending order of row(s) count. Official document in Chinese | English Example In the following example, the returned results will be sorted in ascending order of the matched row(s): import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : ... , group_bys : [ group_by_field ( &quot;group_name&quot; , &quot;type&quot; , sub_group_bys : [ ... ] , sort : [ row_count_sort ( :asc ) ] ) ] ]","ref":"ExAliyunOts.Search.html#row_count_sort/1","title":"ExAliyunOts.Search.row_count_sort/1","type":"function"},{"doc":"Sort by the relevance score to apply the full-text indexing properly, use it in the nested :sort option of :search_query option in ExAliyunOts/search/4 .","ref":"ExAliyunOts.Search.html#score_sort/1","title":"ExAliyunOts.Search.score_sort/1","type":"function"},{"doc":"Use in group_by_field/3 scenario, in ascending/descending order of the value from sub statistics. Official document in Chinese | English","ref":"ExAliyunOts.Search.html#sub_agg_sort/2","title":"ExAliyunOts.Search.sub_agg_sort/2","type":"function"},{"doc":"Use TermQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : term_query ( &quot;age&quot; , 28 ) ]","ref":"ExAliyunOts.Search.html#term_query/2","title":"ExAliyunOts.Search.term_query/2","type":"function"},{"doc":"Use TermsQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : terms_query ( &quot;age&quot; , [ 28 , 29 , 30 ] ) ]","ref":"ExAliyunOts.Search.html#terms_query/2","title":"ExAliyunOts.Search.terms_query/2","type":"function"},{"doc":"Use WildcardQuery as the nested :query option of :search_query option in ExAliyunOts.search/4 . Official document in Chinese | English Example import MyApp.TableStore search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : wildcard_query ( &quot;name&quot; , &quot;n*&quot; ) ]","ref":"ExAliyunOts.Search.html#wildcard_query/2","title":"ExAliyunOts.Search.wildcard_query/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Sequence.html","title":"ExAliyunOts.Sequence","type":"module"},{"doc":"","ref":"ExAliyunOts.Sequence.html#create/2","title":"ExAliyunOts.Sequence.create/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Sequence.html#delete/2","title":"ExAliyunOts.Sequence.delete/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Sequence.html#delete_event/3","title":"ExAliyunOts.Sequence.delete_event/3","type":"function"},{"doc":"","ref":"ExAliyunOts.Sequence.html#next_value/2","title":"ExAliyunOts.Sequence.next_value/2","type":"function"},{"doc":"Tablestore Timeline model implements.","ref":"ExAliyunOts.Timeline.html","title":"ExAliyunOts.Timeline","type":"module"},{"doc":"","ref":"ExAliyunOts.Timeline.html#add_field/3","title":"ExAliyunOts.Timeline.add_field/3","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#batch_store/1","title":"ExAliyunOts.Timeline.batch_store/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#change_identifier/2","title":"ExAliyunOts.Timeline.change_identifier/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#change_seq_id/3","title":"ExAliyunOts.Timeline.change_seq_id/3","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#create/1","title":"ExAliyunOts.Timeline.create/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#default_seq_id_col_name/0","title":"ExAliyunOts.Timeline.default_seq_id_col_name/0","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#delete/2","title":"ExAliyunOts.Timeline.delete/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#drop/1","title":"ExAliyunOts.Timeline.drop/1","type":"function"},{"doc":"For manual generation sequence_id.","ref":"ExAliyunOts.Timeline.html#generate_sequence_id/0","title":"ExAliyunOts.Timeline.generate_sequence_id/0","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#get/3","title":"ExAliyunOts.Timeline.get/3","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#new/1","title":"ExAliyunOts.Timeline.new/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#scan_backward/4","title":"ExAliyunOts.Timeline.scan_backward/4","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#scan_forward/4","title":"ExAliyunOts.Timeline.scan_forward/4","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#store/2","title":"ExAliyunOts.Timeline.store/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.html#update/2","title":"ExAliyunOts.Timeline.update/2","type":"function"},{"doc":"Tablestore Timeline meta implements.","ref":"ExAliyunOts.Timeline.Meta.html","title":"ExAliyunOts.Timeline.Meta","type":"module"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#add_field/3","title":"ExAliyunOts.Timeline.Meta.add_field/3","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#change_identifier/2","title":"ExAliyunOts.Timeline.Meta.change_identifier/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#change_info/2","title":"ExAliyunOts.Timeline.Meta.change_info/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#create/1","title":"ExAliyunOts.Timeline.Meta.create/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#delete/1","title":"ExAliyunOts.Timeline.Meta.delete/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#drop/1","title":"ExAliyunOts.Timeline.Meta.drop/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#insert/1","title":"ExAliyunOts.Timeline.Meta.insert/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#new/1","title":"ExAliyunOts.Timeline.Meta.new/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#read/2","title":"ExAliyunOts.Timeline.Meta.read/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Timeline.Meta.html#update/1","title":"ExAliyunOts.Timeline.Meta.update/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Tunnel.Channel.html","title":"ExAliyunOts.Tunnel.Channel","type":"module"},{"doc":"","ref":"ExAliyunOts.Tunnel.Channel.html#callback_mode/0","title":"ExAliyunOts.Tunnel.Channel.callback_mode/0","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor in Elixir v1.6+.","ref":"ExAliyunOts.Tunnel.Channel.html#child_spec/1","title":"ExAliyunOts.Tunnel.Channel.child_spec/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Tunnel.Channel.html#start_link/6","title":"ExAliyunOts.Tunnel.Channel.start_link/6","type":"function"},{"doc":"","ref":"ExAliyunOts.Tunnel.Channel.html#stop/1","title":"ExAliyunOts.Tunnel.Channel.stop/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Tunnel.Channel.html#update/2","title":"ExAliyunOts.Tunnel.Channel.update/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Tunnel.Channel.html#t:channel/0","title":"ExAliyunOts.Tunnel.Channel.channel/0","type":"type"},{"doc":"","ref":"ExAliyunOts.Tunnel.Worker.html","title":"ExAliyunOts.Tunnel.Worker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"ExAliyunOts.Tunnel.Worker.html#child_spec/1","title":"ExAliyunOts.Tunnel.Worker.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"ExAliyunOts.Tunnel.Worker.html#init/1","title":"ExAliyunOts.Tunnel.Worker.init/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Tunnel.Worker.html#start/2","title":"ExAliyunOts.Tunnel.Worker.start/2","type":"function"},{"doc":"","ref":"ExAliyunOts.Tunnel.Worker.html#start_link/1","title":"ExAliyunOts.Tunnel.Worker.start_link/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Tunnel.Worker.html#stop/1","title":"ExAliyunOts.Tunnel.Worker.stop/1","type":"function"},{"doc":"Common tools.","ref":"ExAliyunOts.Utils.html","title":"ExAliyunOts.Utils","type":"module"},{"doc":"","ref":"ExAliyunOts.Utils.html#attrs_to_row/1","title":"ExAliyunOts.Utils.attrs_to_row/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Utils.html#downcase_atom/1","title":"ExAliyunOts.Utils.downcase_atom/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Utils.html#row_to_map/1","title":"ExAliyunOts.Utils.row_to_map/1","type":"function"},{"doc":"","ref":"ExAliyunOts.Utils.html#valid_geo_point?/1","title":"ExAliyunOts.Utils.valid_geo_point?/1","type":"function"},{"doc":"ExAliyunOts Aliyun TableStore SDK for Elixir/Erlang TableStore is a NoSQL database service built on Alibaba Cloud’s Apsara distributed operating system that can store and access large volumes of structured data in real time.","ref":"readme.html","title":"ExAliyunOts","type":"extras"},{"doc":"def deps do [ { :ex_aliyun_ots , &quot;~&gt; 0.11&quot; } ] end","ref":"readme.html#installation","title":"ExAliyunOts - Installation","type":"extras"},{"doc":"Add these settings below into the config/ots.secret.exs file. config :ex_aliyun_ots , :my_instance , name : &quot;MyInstanceName&quot; , endpoint : &quot;MyInstanceEndpoint&quot; , access_key_id : &quot;MyAliyunRAMKeyID&quot; , access_key_secret : &quot;MyAliyunRAMKeySecret&quot; , pool_size : 100 , pool_count : 1 config :ex_aliyun_ots , instances : [ :my_instance ] , debug : false , enable_tunnel : false debug , optional, specifies whether to enable debug logger, by default it is false, and please DO NOT use debug mode in production. enable_tunnel , optional, specifies whether to enable tunnel functions, there will startup tunnel related supervisor and registry when enable it, by default it is false. pool_size , optional, number of connections to maintain in each pool, involved when use Finch as Tesla http adapter, see Finch.request/6 for details, defaults to 100. pool_count , optional, number of pools to start, involved when use Finch as Tesla http adapter, see Finch.request/6 for details, defaults to 1.","ref":"readme.html#configuration","title":"ExAliyunOts - Configuration","type":"extras"},{"doc":"To use ExAliyunOts , a module that calls use ExAliyunOts has to be defined: defmodule MyApp.TableStore do use ExAliyunOts , instance : :my_instance end This automatically defines some macros and functions in the MyApp.TableStore module, here are some examples: import MyApp.TableStore # Create table create_table &quot;table&quot; , [ { &quot;pk1&quot; , :integer } , { &quot;pk2&quot; , :string } ] # Put row put_row &quot;table&quot; , [ { &quot;pk1&quot; , &quot;id1&quot; } ] , [ { &quot;attr1&quot; , 10 } , { &quot;attr2&quot; , &quot;attr2_value&quot; } ] , condition : condition ( :expect_not_exist ) , return_type : :pk # Search index search &quot;table&quot; , &quot;index_name&quot; , search_query : [ query : match_query ( &quot;age&quot; , 28 ) , sort : [ field_sort ( &quot;age&quot; , order : :desc ) ] ] # Local transaction start_local_transaction &quot;table&quot; , { &quot;partition_key&quot; , &quot;partition_value&quot; }","ref":"readme.html#using-exaliyunots","title":"ExAliyunOts - Using ExAliyunOts","type":"extras"},{"doc":"There are two ways to use ExAliyunOts: using macros and functions from your own ExAliyunOts module, like MyApp.TableStore . using macros and functions from the ExAliyunOts module. All defined functions and macros in ExAliyunOts are available and referable for your own ExAliyunOts module as well, except that the given arity of functions may different, because the instance parameter of each invoke request is NOT needed from your own ExAliyunOts module although the ExAliyunOts module defines it.","ref":"readme.html#exaliyunots-api","title":"ExAliyunOts - ExAliyunOts API","type":"extras"},{"doc":"Here is a Tablestore adapter for Ecto implementation as an alternative.","ref":"readme.html#ecto-adapter","title":"ExAliyunOts - Ecto Adapter","type":"extras"},{"doc":"Table Operations Row Operations Conditional update Auto-increment function of the primary key column Filter Atomic counters Search index Local transaction Tunnel service Timeline mode","ref":"readme.html#supported-functions","title":"ExAliyunOts - Supported Functions","type":"extras"},{"doc":"Table CreateTable ListTable DeleteTable UpdateTable DescribeTable ComputeSplitPointsBySize Row PutRow GetRow UpdateRow DeleteRow GetRange BatchGetRow BatchWriteRow SearchIndex CreateSearchIndex DescribeSearchIndex DeleteSearchIndex Search ParallelScan LocalTransaction StartLocalTransaction CommitTransaction AbortTransaction SDK built-in IterateAllRange IterateParallelScan IterateSearch Sequence StreamParallelScan StreamRange StreamSearch Tunnel service Timeline mode","ref":"readme.html#supported-api","title":"ExAliyunOts - Supported API","type":"extras"},{"doc":"Thanks very much for the help and support of the Alibaba TableStore offical support team.","ref":"readme.html#thanks","title":"ExAliyunOts - Thanks","type":"extras"},{"doc":"Alibaba Tablestore product official references: English document 中文文档","ref":"readme.html#references","title":"ExAliyunOts - References","type":"extras"},{"doc":"This project is licensed under the MIT license. Copyright (c) 2018- Xin Zou.","ref":"readme.html#license","title":"ExAliyunOts - License","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Imporve further plainbuffer encoding(cover crc_int32 and crc_int64 ) performance","ref":"changelog.html#v0-13-1-2021-04-20","title":"Changelog - v0.13.1 (2021-04-20)","type":"extras"},{"doc":"Enhance CRC module to imporve plainbuffer encoding performance","ref":"changelog.html#v0-13-0-2021-04-20","title":"Changelog - v0.13.0 (2021-04-20)","type":"extras"},{"doc":"Add :is_atomic option to ExAliyunOts.batch_write/3 Tweak document of ExAliyunOts module","ref":"changelog.html#v0-12-4-2021-04-12","title":"Changelog - v0.12.4 (2021-04-12)","type":"extras"},{"doc":"Make compatible to use :crypto mac","ref":"changelog.html#v0-12-3-2021-03-02","title":"Changelog - v0.12.3 (2021-03-02)","type":"extras"},{"doc":"Add ExAliyunOts.stream_search/4 Add ExAliyunOts.iterate_search/4 Fix compile warning when generate docs","ref":"changelog.html#v0-12-2-2021-01-21","title":"Changelog - v0.12.2 (2021-01-21)","type":"extras"},{"doc":"Fix Elixir 1.11 compilation warnings, explicitly add Jason into mix.exs deps","ref":"changelog.html#v0-12-1-2021-01-15","title":"Changelog - v0.12.1 (2021-01-15)","type":"extras"},{"doc":"Fix Elixir 1.11 compilation warnings","ref":"changelog.html#v0-12-0-2021-01-15","title":"Changelog - v0.12.0 (2021-01-15)","type":"extras"},{"doc":"Remove internal error logger print when occurs OTSConditionCheckFail , OTSObjectAlreadyExist and OTSObjectNotExist","ref":"changelog.html#v0-11-1-2021-01-12","title":"Changelog - v0.11.1 (2021-01-12)","type":"extras"},{"doc":"NOTICE : Since this version changes, when upgrade this library to 0.11.0 or higher version, if also use ecto_tablestore , please upgrade ecto_tablestore to 0.8.0 or higher version. Use protox to replace exportobuf for google protobuf library, and maintain the generated modules in hexpm Add retry for http request timeout Some implicit modules are removed and directly use the generated protobuf modules, cover: Use ExAliyunOts.TableStoreFilter.Filter(in tablestore_protos ) to replace ExAliyunOts.Var.Filter Use ExAliyunOts.TableStoreFilter.SingleColumnValueFilter(in tablestore_protos ) to replace ExAliyunOts.Var.SingleColumnValueFilter Use ExAliyunOts.TableStoreFilter.ColumnPaginationFilter(in tablestore_protos ) to replace ExAliyunOts.Var.ColumnPaginationFilter Use ExAliyunOts.TableStore.Condition(in tablestore_protos ) to replace ExAliyunOts.Var.Condition Improve module file struct/naming Add ExAliyunOts.create_index/6 to create global secondary indexes Add index_metas and defined_columns optional options when use ExAliyunOts.create_table/4","ref":"changelog.html#v0-11-0-2020-12-10","title":"Changelog - v0.11.0 (2020-12-10)","type":"extras"},{"doc":"Improve plainbuffer decoding performance","ref":"changelog.html#v0-10-0-2020-12-04","title":"Changelog - v0.10.0 (2020-12-04)","type":"extras"},{"doc":"[Http] Use Tesla with Finch adapter","ref":"changelog.html#v0-9-0-2020-11-17","title":"Changelog - v0.9.0 (2020-11-17)","type":"extras"},{"doc":"[Table] Add ExAliyunOts.compute_split_points_by_size/3 [Table] Fix shard_splits of DescribeTable response in proper decoded format [SearchIndex] Add ParallelScan functions Implement standard api ExAliyunOts.compute_splits/3 Implement standard api ExAliyunOts.parallel_scan/4 Implement built-in functions ExAliyunOts.iterate_parallel_scan/5 , ExAliyunOts.iterate_parallel_scan/7 and ExAliyunOts.stream_parallel_scan/4 to make general use cases simple","ref":"changelog.html#v0-8-0-2020-11-13","title":"Changelog - v0.8.0 (2020-11-13)","type":"extras"},{"doc":"Enhance condition expression and simplify some code about it","ref":"changelog.html#v0-7-1-2020-09-15","title":"Changelog - v0.7.1 (2020-09-15)","type":"extras"},{"doc":"Update ExAliyunOts.filter/1 for a better usage (please notice that this change is incompatible update), before this version uses filter like this: filter ( &quot;name[ignore_if_missing: true, latest_version_only: true]&quot; == var_name and &quot;age&quot; &gt; 1 ) after this version uses filter like this, and then the column_name &quot;name&quot; can bind variable of the context filter ( { &quot;name&quot; , ignore_if_missing : true , latest_version_only : true } == var_name and &quot;age&quot; &gt; 1 )","ref":"changelog.html#v0-7-0-2020-09-15","title":"Changelog - v0.7.0 (2020-09-15)","type":"extras"},{"doc":"Add ExAliyunOts.stream_range/5 Add index_sorts option when create search index Remove Mix in runtime Support filter expression column_name to bind variable of the context Enhance condition expression Tweak plainbuffer Downgrade hackney to 1.15.2","ref":"changelog.html#v0-6-10-2020-09-15","title":"Changelog - v0.6.10 (2020-09-15)","type":"extras"}]